import { toFail, toText, printf, validateGuid, join } from "../fable-library.2.4.11/String";
import { int16ToString, mapCurriedArgs, compare, comparePrimitives, uncurry, int32ToString, partialApply } from "../fable-library.2.4.11/Util";
import { map as map$$4, mapOk, defaultArg, some, Result } from "../fable-library.2.4.11/Option";
import { Util$$$CachedDecoders as Util$0024$0024$0024CachedDecoders, Util$002ECache$00601$$GetOrAdd$$43981464 as Util$0024002ECache$002400601$0024$0024GetOrAdd$0024$002443981464, CaseStrategy, Util$002ECasing$$$convert as Util$0024002ECasing$0024$0024$0024convert, ErrorReason } from "./Types";
import { tryParse as tryParse$$16 } from "../fable-library.2.4.11/Int32";
import { tryParse as tryParse$$17, fromNumber, toNumber, fromBits } from "../fable-library.2.4.11/Long";
import { parse, fromInt32 } from "../fable-library.2.4.11/BigInt";
import { tryParse as tryParse$$18 } from "../fable-library.2.4.11/Decimal";
import Decimal from "../fable-library.2.4.11/Decimal";
import { toUniversalTime, tryParse as tryParse$$19, minValue } from "../fable-library.2.4.11/Date";
import { tryParse as tryParse$$20, minValue as minValue$$1 } from "../fable-library.2.4.11/DateOffset";
import { tryParse as tryParse$$21 } from "../fable-library.2.4.11/TimeSpan";
import { FSharpRef, declare, List } from "../fable-library.2.4.11/Types";
import { ofArray, map as map$$1, length, append as append$$1, ofSeq, reverse, fold, tryLast } from "../fable-library.2.4.11/List";
import { ofList as ofList$$1, map as map$$2, tryFind, foldBack2, foldBack, fill, fold as fold$$1 } from "../fable-library.2.4.11/Array";
import { contains, fold as fold$$2, reverse as reverse$$1, append } from "../fable-library.2.4.11/Seq";
import { empty, map as map$$3, tryFind as tryFind$$1, add, ofSeq as ofSeq$$1, ofList } from "../fable-library.2.4.11/Map";
import { getGenerics, getGenericTypeDefinition, makeTuple, getTupleElements, isTuple, isGenericType, parseEnum, getEnumValues, getEnumUnderlyingType, isEnum, getElementType, isArray, isUnion, makeRecord, getRecordElements, isRecord, fullName, getUnionCaseFields, makeUnion as makeUnion$$1, name as name$$22, getUnionCases, type } from "../fable-library.2.4.11/Reflection";
import { ofSeq as ofSeq$$2 } from "../fable-library.2.4.11/Set";
export function Helpers$$$isUndefined(o) {
  return typeof o === "undefined";
}

function genericMsg(msg, value$$1, newLine) {
  try {
    return "Expecting " + msg + " but instead got:" + (newLine ? "\n" : " ") + (JSON.stringify(value$$1, null, 4) + "");
  } catch (matchValue) {
    return "Expecting " + msg + " but decoder failed. Couldn't report given value due to circular structure." + (newLine ? "\n" : " ");
  }
}

function errorToString(path, error) {
  const reason$$1 = error.tag === 2 ? genericMsg(error.fields[0], error.fields[1], true) : error.tag === 1 ? genericMsg(error.fields[0], error.fields[1], false) + "\nReason: " + error.fields[2] : error.tag === 3 ? genericMsg(error.fields[0], error.fields[1], true) : error.tag === 4 ? genericMsg(error.fields[0], error.fields[1], true) + ("\nNode `" + error.fields[2] + "` is unkown.") : error.tag === 5 ? "Expecting " + error.fields[0] + ".\n" + (JSON.stringify(error.fields[1], null, 4) + "") : error.tag === 7 ? "The following errors were found:\n\n" + join("\n\n", error.fields[0]) : error.tag === 6 ? "The following `failure` occurred with the decoder: " + error.fields[0] : genericMsg(error.fields[0], error.fields[1], false);

  if (error.tag === 7) {
    return reason$$1;
  } else {
    return "Error at: `" + path + "`\n" + reason$$1;
  }
}

export function fromValue(path$$1, decoder, value$$8) {
  let matchValue$$1;
  const clo1 = partialApply(1, decoder, [path$$1]);
  matchValue$$1 = clo1(value$$8);

  if (matchValue$$1.tag === 1) {
    return new Result(1, "Error", errorToString(matchValue$$1.fields[0][0], matchValue$$1.fields[0][1]));
  } else {
    return new Result(0, "Ok", matchValue$$1.fields[0]);
  }
}
export function fromString(decoder$$1, value$$9) {
  try {
    const json = JSON.parse(value$$9);
    return fromValue("$", decoder$$1, json);
  } catch (matchValue$$2) {
    if (matchValue$$2 instanceof SyntaxError) {
      return new Result(1, "Error", "Given an invalid JSON: " + matchValue$$2.message);
    } else {
      throw matchValue$$2;
    }
  }
}
export function unsafeFromString(decoder$$2, value$$10) {
  const matchValue$$3 = fromString(decoder$$2, value$$10);

  if (matchValue$$3.tag === 1) {
    throw new Error(matchValue$$3.fields[0]);
  } else {
    return matchValue$$3.fields[0];
  }
}
export function decodeValue(path$$3, decoder$$3) {
  return function (value$$11) {
    return fromValue(path$$3, decoder$$3, value$$11);
  };
}
export function decodeString(decoder$$5) {
  return function (value$$12) {
    return fromString(decoder$$5, value$$12);
  };
}
export function string(path$$4, value$$13) {
  if (typeof value$$13 === "string") {
    return new Result(0, "Ok", value$$13);
  } else {
    const arg0 = [path$$4, new ErrorReason(0, "BadPrimitive", "a string", value$$13)];
    return new Result(1, "Error", arg0);
  }
}
export function guid(path$$5, value$$14) {
  if (typeof value$$14 === "string") {
    const matchValue$$4 = validateGuid(value$$14, true);

    if (matchValue$$4[0]) {
      return new Result(0, "Ok", matchValue$$4[1]);
    } else {
      const arg0$$1 = [path$$5, new ErrorReason(0, "BadPrimitive", "a guid", value$$14)];
      return new Result(1, "Error", arg0$$1);
    }
  } else {
    const arg0$$2 = [path$$5, new ErrorReason(0, "BadPrimitive", "a guid", value$$14)];
    return new Result(1, "Error", arg0$$2);
  }
}
export function unit(path$$6, value$$15) {
  if (value$$15 == null) {
    return new Result(0, "Ok", null);
  } else {
    const arg0$$3 = [path$$6, new ErrorReason(0, "BadPrimitive", "null", value$$15)];
    return new Result(1, "Error", arg0$$3);
  }
}
export function sbyte(path$$7) {
  return function (value$$17) {
    if (typeof value$$17 === "number") {
      const value$$19 = value$$17;

      if (isFinite(value$$19) && Math.floor(value$$19) === value$$19) {
        if (-128 <= value$$19 ? value$$19 <= 127 : false) {
          return new Result(0, "Ok", ((value$$19 + 0x80 & 0xFF) - 0x80));
        } else {
          const arg0$$4 = [path$$7, new ErrorReason(1, "BadPrimitiveExtra", "a sbyte", value$$19, "Value was either too large or too small for a sbyte")];
          return new Result(1, "Error", arg0$$4);
        }
      } else {
        const arg0$$5 = [path$$7, new ErrorReason(1, "BadPrimitiveExtra", "a sbyte", value$$19, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$5);
      }
    } else if (typeof value$$17 === "string") {
      let matchValue$$5;
      const arg00$$1 = value$$17;
      matchValue$$5 = tryParse$$16(arg00$$1, 511, false, 8);

      if (matchValue$$5[0]) {
        return new Result(0, "Ok", matchValue$$5[1]);
      } else {
        const arg0$$6 = [path$$7, new ErrorReason(0, "BadPrimitive", "a sbyte", value$$17)];
        return new Result(1, "Error", arg0$$6);
      }
    } else {
      const arg0$$7 = [path$$7, new ErrorReason(0, "BadPrimitive", "a sbyte", value$$17)];
      return new Result(1, "Error", arg0$$7);
    }
  };
}
export function byte$(path$$9) {
  return function (value$$21) {
    if (typeof value$$21 === "number") {
      const value$$23 = value$$21;

      if (isFinite(value$$23) && Math.floor(value$$23) === value$$23) {
        if (0 <= value$$23 ? value$$23 <= 255 : false) {
          return new Result(0, "Ok", (value$$23 & 0xFF));
        } else {
          const arg0$$8 = [path$$9, new ErrorReason(1, "BadPrimitiveExtra", "a byte", value$$23, "Value was either too large or too small for a byte")];
          return new Result(1, "Error", arg0$$8);
        }
      } else {
        const arg0$$9 = [path$$9, new ErrorReason(1, "BadPrimitiveExtra", "a byte", value$$23, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$9);
      }
    } else if (typeof value$$21 === "string") {
      let matchValue$$6;
      const arg00$$2 = value$$21;
      matchValue$$6 = tryParse$$16(arg00$$2, 511, true, 8);

      if (matchValue$$6[0]) {
        return new Result(0, "Ok", matchValue$$6[1]);
      } else {
        const arg0$$10 = [path$$9, new ErrorReason(0, "BadPrimitive", "a byte", value$$21)];
        return new Result(1, "Error", arg0$$10);
      }
    } else {
      const arg0$$11 = [path$$9, new ErrorReason(0, "BadPrimitive", "a byte", value$$21)];
      return new Result(1, "Error", arg0$$11);
    }
  };
}
export function int16(path$$11) {
  return function (value$$25) {
    if (typeof value$$25 === "number") {
      const value$$27 = value$$25;

      if (isFinite(value$$27) && Math.floor(value$$27) === value$$27) {
        if (-32768 <= value$$27 ? value$$27 <= 32767 : false) {
          return new Result(0, "Ok", ((value$$27 + 0x8000 & 0xFFFF) - 0x8000));
        } else {
          const arg0$$12 = [path$$11, new ErrorReason(1, "BadPrimitiveExtra", "an int16", value$$27, "Value was either too large or too small for an int16")];
          return new Result(1, "Error", arg0$$12);
        }
      } else {
        const arg0$$13 = [path$$11, new ErrorReason(1, "BadPrimitiveExtra", "an int16", value$$27, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$13);
      }
    } else if (typeof value$$25 === "string") {
      let matchValue$$7;
      const arg00$$3 = value$$25;
      matchValue$$7 = tryParse$$16(arg00$$3, 511, false, 16);

      if (matchValue$$7[0]) {
        return new Result(0, "Ok", matchValue$$7[1]);
      } else {
        const arg0$$14 = [path$$11, new ErrorReason(0, "BadPrimitive", "an int16", value$$25)];
        return new Result(1, "Error", arg0$$14);
      }
    } else {
      const arg0$$15 = [path$$11, new ErrorReason(0, "BadPrimitive", "an int16", value$$25)];
      return new Result(1, "Error", arg0$$15);
    }
  };
}
export function uint16(path$$13) {
  return function (value$$29) {
    if (typeof value$$29 === "number") {
      const value$$31 = value$$29;

      if (isFinite(value$$31) && Math.floor(value$$31) === value$$31) {
        if (0 <= value$$31 ? value$$31 <= 65535 : false) {
          return new Result(0, "Ok", (value$$31 & 0xFFFF));
        } else {
          const arg0$$16 = [path$$13, new ErrorReason(1, "BadPrimitiveExtra", "an uint16", value$$31, "Value was either too large or too small for an uint16")];
          return new Result(1, "Error", arg0$$16);
        }
      } else {
        const arg0$$17 = [path$$13, new ErrorReason(1, "BadPrimitiveExtra", "an uint16", value$$31, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$17);
      }
    } else if (typeof value$$29 === "string") {
      let matchValue$$8;
      const arg00$$4 = value$$29;
      matchValue$$8 = tryParse$$16(arg00$$4, 511, true, 16);

      if (matchValue$$8[0]) {
        return new Result(0, "Ok", matchValue$$8[1]);
      } else {
        const arg0$$18 = [path$$13, new ErrorReason(0, "BadPrimitive", "an uint16", value$$29)];
        return new Result(1, "Error", arg0$$18);
      }
    } else {
      const arg0$$19 = [path$$13, new ErrorReason(0, "BadPrimitive", "an uint16", value$$29)];
      return new Result(1, "Error", arg0$$19);
    }
  };
}
export function int$(path$$15) {
  return function (value$$33) {
    if (typeof value$$33 === "number") {
      const value$$35 = value$$33;

      if (isFinite(value$$35) && Math.floor(value$$35) === value$$35) {
        if (-2147483648 <= value$$35 ? value$$35 <= 2147483647 : false) {
          return new Result(0, "Ok", (~~value$$35));
        } else {
          const arg0$$20 = [path$$15, new ErrorReason(1, "BadPrimitiveExtra", "an int", value$$35, "Value was either too large or too small for an int")];
          return new Result(1, "Error", arg0$$20);
        }
      } else {
        const arg0$$21 = [path$$15, new ErrorReason(1, "BadPrimitiveExtra", "an int", value$$35, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$21);
      }
    } else if (typeof value$$33 === "string") {
      let matchValue$$9;
      const arg00$$5 = value$$33;
      matchValue$$9 = tryParse$$16(arg00$$5, 511, false, 32);

      if (matchValue$$9[0]) {
        return new Result(0, "Ok", matchValue$$9[1]);
      } else {
        const arg0$$22 = [path$$15, new ErrorReason(0, "BadPrimitive", "an int", value$$33)];
        return new Result(1, "Error", arg0$$22);
      }
    } else {
      const arg0$$23 = [path$$15, new ErrorReason(0, "BadPrimitive", "an int", value$$33)];
      return new Result(1, "Error", arg0$$23);
    }
  };
}
export function uint32(path$$17) {
  return function (value$$37) {
    if (typeof value$$37 === "number") {
      const value$$39 = value$$37;

      if (isFinite(value$$39) && Math.floor(value$$39) === value$$39) {
        if (0 <= value$$39 ? value$$39 <= 4294967295 : false) {
          return new Result(0, "Ok", (value$$39 >>> 0));
        } else {
          const arg0$$24 = [path$$17, new ErrorReason(1, "BadPrimitiveExtra", "an uint32", value$$39, "Value was either too large or too small for an uint32")];
          return new Result(1, "Error", arg0$$24);
        }
      } else {
        const arg0$$25 = [path$$17, new ErrorReason(1, "BadPrimitiveExtra", "an uint32", value$$39, "Value is not an integral value")];
        return new Result(1, "Error", arg0$$25);
      }
    } else if (typeof value$$37 === "string") {
      let matchValue$$10;
      const arg00$$6 = value$$37;
      matchValue$$10 = tryParse$$16(arg00$$6, 511, true, 32);

      if (matchValue$$10[0]) {
        return new Result(0, "Ok", matchValue$$10[1]);
      } else {
        const arg0$$26 = [path$$17, new ErrorReason(0, "BadPrimitive", "an uint32", value$$37)];
        return new Result(1, "Error", arg0$$26);
      }
    } else {
      const arg0$$27 = [path$$17, new ErrorReason(0, "BadPrimitive", "an uint32", value$$37)];
      return new Result(1, "Error", arg0$$27);
    }
  };
}
export const int64 = (() => {
  const min$$12 = fromBits(0, 2147483648, false);
  const max$$12 = fromBits(4294967295, 2147483647, false);
  return function (path$$19) {
    return function (value$$41) {
      if (typeof value$$41 === "number") {
        const value$$43 = value$$41;

        if (isFinite(value$$43) && Math.floor(value$$43) === value$$43) {
          if (toNumber(min$$12) <= value$$43 ? value$$43 <= toNumber(max$$12) : false) {
            return new Result(0, "Ok", (fromNumber(value$$43, false)));
          } else {
            const arg0$$28 = [path$$19, new ErrorReason(1, "BadPrimitiveExtra", "an int64", value$$43, "Value was either too large or too small for an int64")];
            return new Result(1, "Error", arg0$$28);
          }
        } else {
          const arg0$$29 = [path$$19, new ErrorReason(1, "BadPrimitiveExtra", "an int64", value$$43, "Value is not an integral value")];
          return new Result(1, "Error", arg0$$29);
        }
      } else if (typeof value$$41 === "string") {
        let matchValue$$11;
        const arg00$$7 = value$$41;
        matchValue$$11 = tryParse$$17(arg00$$7, 511, false, 64);

        if (matchValue$$11[0]) {
          return new Result(0, "Ok", matchValue$$11[1]);
        } else {
          const arg0$$30 = [path$$19, new ErrorReason(0, "BadPrimitive", "an int64", value$$41)];
          return new Result(1, "Error", arg0$$30);
        }
      } else {
        const arg0$$31 = [path$$19, new ErrorReason(0, "BadPrimitive", "an int64", value$$41)];
        return new Result(1, "Error", arg0$$31);
      }
    };
  };
})();
export const uint64 = (() => {
  const min$$14 = fromBits(0, 0, true);
  const max$$14 = fromBits(4294967295, 4294967295, true);
  return function (path$$21) {
    return function (value$$45) {
      if (typeof value$$45 === "number") {
        const value$$47 = value$$45;

        if (isFinite(value$$47) && Math.floor(value$$47) === value$$47) {
          if (toNumber(min$$14) <= value$$47 ? value$$47 <= toNumber(max$$14) : false) {
            return new Result(0, "Ok", (fromNumber(value$$47, true)));
          } else {
            const arg0$$32 = [path$$21, new ErrorReason(1, "BadPrimitiveExtra", "an uint64", value$$47, "Value was either too large or too small for an uint64")];
            return new Result(1, "Error", arg0$$32);
          }
        } else {
          const arg0$$33 = [path$$21, new ErrorReason(1, "BadPrimitiveExtra", "an uint64", value$$47, "Value is not an integral value")];
          return new Result(1, "Error", arg0$$33);
        }
      } else if (typeof value$$45 === "string") {
        let matchValue$$12;
        const arg00$$8 = value$$45;
        matchValue$$12 = tryParse$$17(arg00$$8, 511, true, 64);

        if (matchValue$$12[0]) {
          return new Result(0, "Ok", matchValue$$12[1]);
        } else {
          const arg0$$34 = [path$$21, new ErrorReason(0, "BadPrimitive", "an uint64", value$$45)];
          return new Result(1, "Error", arg0$$34);
        }
      } else {
        const arg0$$35 = [path$$21, new ErrorReason(0, "BadPrimitive", "an uint64", value$$45)];
        return new Result(1, "Error", arg0$$35);
      }
    };
  };
})();
export function bigint(path$$23, value$$48) {
  if (typeof value$$48 === "number") {
    let arg0$$36;
    const arg00$$9 = value$$48 | 0;
    arg0$$36 = fromInt32(arg00$$9);
    return new Result(0, "Ok", arg0$$36);
  } else if (typeof value$$48 === "string") {
    try {
      const arg0$$37 = parse(value$$48);
      return new Result(0, "Ok", arg0$$37);
    } catch (matchValue$$13) {
      const arg0$$38 = [path$$23, new ErrorReason(0, "BadPrimitive", "a bigint", value$$48)];
      return new Result(1, "Error", arg0$$38);
    }
  } else {
    const arg0$$39 = [path$$23, new ErrorReason(0, "BadPrimitive", "a bigint", value$$48)];
    return new Result(1, "Error", arg0$$39);
  }
}
export function bool(path$$24, value$$49) {
  if (typeof value$$49 === "boolean") {
    return new Result(0, "Ok", value$$49);
  } else {
    const arg0$$40 = [path$$24, new ErrorReason(0, "BadPrimitive", "a boolean", value$$49)];
    return new Result(1, "Error", arg0$$40);
  }
}
export function float$(path$$25, value$$50) {
  if (typeof value$$50 === "number") {
    return new Result(0, "Ok", value$$50);
  } else {
    const arg0$$41 = [path$$25, new ErrorReason(0, "BadPrimitive", "a float", value$$50)];
    return new Result(1, "Error", arg0$$41);
  }
}
export function float32(path$$26, value$$51) {
  if (typeof value$$51 === "number") {
    return new Result(0, "Ok", value$$51);
  } else {
    const arg0$$42 = [path$$26, new ErrorReason(0, "BadPrimitive", "a float32", value$$51)];
    return new Result(1, "Error", arg0$$42);
  }
}
export function decimal(path$$27, value$$52) {
  if (typeof value$$52 === "number") {
    let arg0$$43;
    const value$$53 = value$$52;
    arg0$$43 = new Decimal(value$$53);
    return new Result(0, "Ok", arg0$$43);
  } else if (typeof value$$52 === "string") {
    const matchValue$$14 = tryParse$$18(value$$52);

    if (matchValue$$14[0]) {
      return new Result(0, "Ok", matchValue$$14[1]);
    } else {
      const arg0$$44 = [path$$27, new ErrorReason(0, "BadPrimitive", "a decimal", value$$52)];
      return new Result(1, "Error", arg0$$44);
    }
  } else {
    const arg0$$45 = [path$$27, new ErrorReason(0, "BadPrimitive", "a decimal", value$$52)];
    return new Result(1, "Error", arg0$$45);
  }
}
export function datetime(path$$28, value$$54) {
  if (typeof value$$54 === "string") {
    const matchValue$$15 = tryParse$$19(value$$54, minValue());

    if (matchValue$$15[0]) {
      const arg0$$46 = toUniversalTime(matchValue$$15[1]);
      return new Result(0, "Ok", arg0$$46);
    } else {
      const arg0$$47 = [path$$28, new ErrorReason(0, "BadPrimitive", "a datetime", value$$54)];
      return new Result(1, "Error", arg0$$47);
    }
  } else {
    const arg0$$48 = [path$$28, new ErrorReason(0, "BadPrimitive", "a datetime", value$$54)];
    return new Result(1, "Error", arg0$$48);
  }
}
export function datetimeOffset(path$$29, value$$55) {
  if (typeof value$$55 === "string") {
    const matchValue$$16 = tryParse$$20(value$$55, minValue$$1());

    if (matchValue$$16[0]) {
      return new Result(0, "Ok", matchValue$$16[1]);
    } else {
      const arg0$$49 = [path$$29, new ErrorReason(0, "BadPrimitive", "a datetimeoffset", value$$55)];
      return new Result(1, "Error", arg0$$49);
    }
  } else {
    const arg0$$50 = [path$$29, new ErrorReason(0, "BadPrimitive", "a datetime", value$$55)];
    return new Result(1, "Error", arg0$$50);
  }
}
export function timespan(path$$30, value$$56) {
  if (typeof value$$56 === "string") {
    const matchValue$$17 = tryParse$$21(value$$56, 0);

    if (matchValue$$17[0]) {
      return new Result(0, "Ok", matchValue$$17[1]);
    } else {
      const arg0$$51 = [path$$30, new ErrorReason(0, "BadPrimitive", "a timespan", value$$56)];
      return new Result(1, "Error", arg0$$51);
    }
  } else {
    const arg0$$52 = [path$$30, new ErrorReason(0, "BadPrimitive", "a timespan", value$$56)];
    return new Result(1, "Error", arg0$$52);
  }
}

function decodeMaybeNull(path$$31, decoder$$7, value$$57) {
  var o$$50;
  let matchValue$$18;
  const clo1$$1 = partialApply(1, decoder$$7, [path$$31]);
  matchValue$$18 = clo1$$1(value$$57);

  if (matchValue$$18.tag === 1) {
    if (o$$50 = value$$57, o$$50 == null) {
      return new Result(0, "Ok", null);
    } else {
      if (matchValue$$18.tag === 1) {
        return new Result(1, "Error", matchValue$$18.fields[0]);
      } else {
        throw new Error("The match cases were incomplete");
      }
    }
  } else {
    return new Result(0, "Ok", some(matchValue$$18.fields[0]));
  }
}

export function optional(fieldName$$1, decoder$$8, path$$32, value$$58) {
  if (value$$58 === null ? false : Object.getPrototypeOf(value$$58 || false) === Object.prototype) {
    const fieldValue = value$$58[fieldName$$1];

    if (Helpers$$$isUndefined(fieldValue)) {
      return new Result(0, "Ok", null);
    } else {
      return decodeMaybeNull(path$$32 + "." + fieldName$$1, decoder$$8, fieldValue);
    }
  } else {
    return new Result(1, "Error", [path$$32, new ErrorReason(2, "BadType", "an object", value$$58)]);
  }
}

function badPathError(fieldNames, currentPath, value$$59) {
  var strings, option$$1;
  const currentPath$$1 = defaultArg(currentPath, (strings = new List("$", fieldNames), (join(".", strings))));
  const msg$$9 = "an object with path `" + join(".", fieldNames) + "`";
  return new Result(1, "Error", [currentPath$$1, new ErrorReason(4, "BadPath", msg$$9, value$$59, (option$$1 = tryLast(fieldNames), (defaultArg(option$$1, ""))))]);
}

export function optionalAt(fieldNames$$1, decoder$$9, firstPath, firstValue) {
  let _arg1;

  const state = [firstPath, firstValue, null];
  _arg1 = fold(function folder(tupledArg, field$$1) {
    if (tupledArg[2] == null) {
      if (tupledArg[1] == null) {
        const res$$1 = badPathError(fieldNames$$1, tupledArg[0], firstValue);
        return [tupledArg[0], tupledArg[1], res$$1];
      } else if (tupledArg[1] === null ? false : Object.getPrototypeOf(tupledArg[1] || false) === Object.prototype) {
        const curValue$$1 = tupledArg[1][field$$1];
        return [tupledArg[0] + "." + field$$1, curValue$$1, null];
      } else {
        const res$$2 = new Result(1, "Error", [tupledArg[0], new ErrorReason(2, "BadType", "an object", tupledArg[1])]);
        return [tupledArg[0], tupledArg[1], res$$2];
      }
    } else {
      return [tupledArg[0], tupledArg[1], tupledArg[2]];
    }
  }, state, fieldNames$$1);

  if (_arg1[2] == null) {
    if (Helpers$$$isUndefined(_arg1[1])) {
      return new Result(0, "Ok", null);
    } else {
      return decodeMaybeNull(_arg1[0], decoder$$9, _arg1[1]);
    }
  } else {
    const res$$3 = _arg1[2];
    return res$$3;
  }
}
export function field(fieldName$$4, decoder$$10, path$$33, value$$61) {
  if (value$$61 === null ? false : Object.getPrototypeOf(value$$61 || false) === Object.prototype) {
    const fieldValue$$1 = value$$61[fieldName$$4];

    if (Helpers$$$isUndefined(fieldValue$$1)) {
      return new Result(1, "Error", [path$$33, new ErrorReason(3, "BadField", "an object with a field named `" + fieldName$$4 + "`", value$$61)]);
    } else {
      return decoder$$10(path$$33 + "." + fieldName$$4, fieldValue$$1);
    }
  } else {
    return new Result(1, "Error", [path$$33, new ErrorReason(2, "BadType", "an object", value$$61)]);
  }
}
export function at(fieldNames$$2, decoder$$11, firstPath$$1, firstValue$$1) {
  let _arg1$$1;

  const state$$1 = [firstPath$$1, firstValue$$1, null];
  _arg1$$1 = fold(function folder$$1(tupledArg$$1, field$$2) {
    if (tupledArg$$1[2] == null) {
      if (tupledArg$$1[1] == null) {
        const res$$5 = badPathError(fieldNames$$2, tupledArg$$1[0], firstValue$$1);
        return [tupledArg$$1[0], tupledArg$$1[1], res$$5];
      } else if (tupledArg$$1[1] === null ? false : Object.getPrototypeOf(tupledArg$$1[1] || false) === Object.prototype) {
        const curValue$$3 = tupledArg$$1[1][field$$2];

        if (Helpers$$$isUndefined(curValue$$3)) {
          const res$$6 = badPathError(fieldNames$$2, null, firstValue$$1);
          return [tupledArg$$1[0], curValue$$3, res$$6];
        } else {
          return [tupledArg$$1[0] + "." + field$$2, curValue$$3, null];
        }
      } else {
        const res$$7 = new Result(1, "Error", [tupledArg$$1[0], new ErrorReason(2, "BadType", "an object", tupledArg$$1[1])]);
        return [tupledArg$$1[0], tupledArg$$1[1], res$$7];
      }
    } else {
      return [tupledArg$$1[0], tupledArg$$1[1], tupledArg$$1[2]];
    }
  }, state$$1, fieldNames$$2);

  if (_arg1$$1[2] == null) {
    return decoder$$11(_arg1$$1[0], _arg1$$1[1]);
  } else {
    const res$$8 = _arg1$$1[2];
    return res$$8;
  }
}
export function index(requestedIndex, decoder$$12, path$$34, value$$62) {
  var copyOfStruct;
  const currentPath$$2 = path$$34 + ".[" + int32ToString(requestedIndex) + "]";

  if (Array.isArray(value$$62)) {
    const vArray = value$$62;

    if (requestedIndex < vArray.length) {
      return decoder$$12(currentPath$$2, vArray[requestedIndex]);
    } else {
      const msg$$10 = "a longer array. Need index `" + int32ToString(requestedIndex) + "` but there are only `" + (copyOfStruct = vArray.length | 0, int32ToString(copyOfStruct)) + "` entries";
      const arg0$$53 = [currentPath$$2, new ErrorReason(5, "TooSmallArray", msg$$10, value$$62)];
      return new Result(1, "Error", arg0$$53);
    }
  } else {
    const arg0$$54 = [currentPath$$2, new ErrorReason(0, "BadPrimitive", "an array", value$$62)];
    return new Result(1, "Error", arg0$$54);
  }
}
export function option(decoder$$13, path$$35, value$$63) {
  if (value$$63 == null) {
    return new Result(0, "Ok", null);
  } else {
    const result = decoder$$13(path$$35, value$$63);
    return mapOk(function mapping(arg0$$55) {
      return some(arg0$$55);
    }, result);
  }
}
export function list(decoder$$14, path$$36, value$$64) {
  if (Array.isArray(value$$64)) {
    let i = -1 | 0;
    const tokens = value$$64;
    let result$$1;
    const state$$2 = new Result(0, "Ok", new List());
    result$$1 = fold$$1(function folder$$2(acc, value$$65) {
      i = i + 1;

      if (acc.tag === 0) {
        const matchValue$$19 = decoder$$14(path$$36 + ".[" + int32ToString(i) + "]", value$$65);

        if (matchValue$$19.tag === 0) {
          return new Result(0, "Ok", new List(matchValue$$19.fields[0], acc.fields[0]));
        } else {
          return new Result(1, "Error", matchValue$$19.fields[0]);
        }
      } else {
        return acc;
      }
    }, state$$2, tokens);
    return mapOk(reverse, result$$1);
  } else {
    const arg0$$56 = [path$$36, new ErrorReason(0, "BadPrimitive", "a list", value$$64)];
    return new Result(1, "Error", arg0$$56);
  }
}
export function seq(decoder$$15, path$$37, value$$67) {
  if (Array.isArray(value$$67)) {
    let i$$1 = -1 | 0;
    const tokens$$1 = value$$67;
    let result$$2;
    const state$$3 = new Result(0, "Ok", []);
    result$$2 = fold$$1(function folder$$3(acc$$2, value$$68) {
      i$$1 = i$$1 + 1;

      if (acc$$2.tag === 0) {
        const matchValue$$20 = decoder$$15(path$$37 + ".[" + int32ToString(i$$1) + "]", value$$68);

        if (matchValue$$20.tag === 0) {
          return new Result(0, "Ok", append([matchValue$$20.fields[0]], acc$$2.fields[0]));
        } else {
          return new Result(1, "Error", matchValue$$20.fields[0]);
        }
      } else {
        return acc$$2;
      }
    }, state$$3, tokens$$1);
    return mapOk(reverse$$1, result$$2);
  } else {
    const arg0$$57 = [path$$37, new ErrorReason(0, "BadPrimitive", "a seq", value$$67)];
    return new Result(1, "Error", arg0$$57);
  }
}
export function array(decoder$$16, path$$38, value$$70) {
  if (Array.isArray(value$$70)) {
    let i$$2 = -1 | 0;
    const tokens$$2 = value$$70;
    const arr = fill(new Array(tokens$$2.length), 0, tokens$$2.length, null);
    const state$$4 = new Result(0, "Ok", arr);
    return fold$$1(function folder$$4(acc$$4, value$$71) {
      i$$2 = i$$2 + 1;

      if (acc$$4.tag === 0) {
        const matchValue$$21 = decoder$$16(path$$38 + ".[" + int32ToString(i$$2) + "]", value$$71);

        if (matchValue$$21.tag === 0) {
          acc$$4.fields[0][i$$2] = matchValue$$21.fields[0];
          return new Result(0, "Ok", acc$$4.fields[0]);
        } else {
          return new Result(1, "Error", matchValue$$21.fields[0]);
        }
      } else {
        return acc$$4;
      }
    }, state$$4, tokens$$2);
  } else {
    const arg0$$58 = [path$$38, new ErrorReason(0, "BadPrimitive", "an array", value$$70)];
    return new Result(1, "Error", arg0$$58);
  }
}
export function keys(path$$39, value$$73) {
  if (value$$73 === null ? false : Object.getPrototypeOf(value$$73 || false) === Object.prototype) {
    let arg0$$59;
    const source$$1 = Object.keys(value$$73);
    arg0$$59 = ofSeq(source$$1);
    return new Result(0, "Ok", arg0$$59);
  } else {
    const arg0$$60 = [path$$39, new ErrorReason(0, "BadPrimitive", "an object", value$$73)];
    return new Result(1, "Error", arg0$$60);
  }
}
export function keyValuePairs(decoder$$17, path$$40, value$$74) {
  const matchValue$$22 = keys(path$$40, value$$74);

  if (matchValue$$22.tag === 1) {
    return new Result(1, "Error", matchValue$$22.fields[0]);
  } else {
    let result$$3;
    const state$$5 = new Result(0, "Ok", new List());
    result$$3 = fold(function folder$$5(acc$$6, prop) {
      if (acc$$6.tag === 0) {
        const matchValue$$23 = decoder$$17(path$$40, value$$74[prop]);

        if (matchValue$$23.tag === 0) {
          const arg0$$61 = new List([prop, matchValue$$23.fields[0]], acc$$6.fields[0]);
          return new Result(0, "Ok", arg0$$61);
        } else {
          return new Result(1, "Error", matchValue$$23.fields[0]);
        }
      } else {
        return acc$$6;
      }
    }, state$$5, matchValue$$22.fields[0]);
    return mapOk(reverse, result$$3);
  }
}
export function oneOf(decoders, path$$41, value$$76) {
  const runner = function runner($decoders$$1$$107, $errors$$108) {
    runner: while (true) {
      const decoders$$1 = $decoders$$1$$107,
            errors = $errors$$108;

      if (decoders$$1.tail == null) {
        const arg0$$62 = [path$$41, new ErrorReason(7, "BadOneOf", errors)];
        return new Result(1, "Error", arg0$$62);
      } else {
        const matchValue$$24 = fromValue(path$$41, uncurry(2, decoders$$1.head), value$$76);

        if (matchValue$$24.tag === 1) {
          $decoders$$1$$107 = decoders$$1.tail;
          $errors$$108 = append$$1(errors, new List(matchValue$$24.fields[0], new List()));
          continue runner;
        } else {
          return new Result(0, "Ok", matchValue$$24.fields[0]);
        }
      }

      break;
    }
  };

  return runner(decoders, new List());
}
export function nil(output, path$$42, value$$77) {
  if (value$$77 == null) {
    return new Result(0, "Ok", output);
  } else {
    const arg0$$63 = [path$$42, new ErrorReason(0, "BadPrimitive", "null", value$$77)];
    return new Result(1, "Error", arg0$$63);
  }
}
export function value(_arg1$$2, v$$2) {
  return new Result(0, "Ok", v$$2);
}
export function succeed(output$$1, _arg2, _arg1$$3) {
  return new Result(0, "Ok", output$$1);
}
export function fail(msg$$11, path$$43, _arg1$$4) {
  const arg0$$64 = [path$$43, new ErrorReason(6, "FailMessage", msg$$11)];
  return new Result(1, "Error", arg0$$64);
}
export function andThen(cb, decoder$$18, path$$44, value$$78) {
  const matchValue$$25 = decoder$$18(path$$44, value$$78);

  if (matchValue$$25.tag === 0) {
    return cb(matchValue$$25.fields[0], path$$44, value$$78);
  } else {
    return new Result(1, "Error", matchValue$$25.fields[0]);
  }
}
export function all(decoders$$2, path$$45, value$$79) {
  const runner$$1 = function runner$$1($decoders$$3$$127, $values$$128) {
    runner$$1: while (true) {
      const decoders$$3 = $decoders$$3$$127,
            values = $values$$128;

      if (decoders$$3.tail == null) {
        return new Result(0, "Ok", values);
      } else {
        const matchValue$$26 = decoders$$3.head(path$$45)(value$$79);

        if (matchValue$$26.tag === 1) {
          return new Result(1, "Error", matchValue$$26.fields[0]);
        } else {
          $decoders$$3$$127 = decoders$$3.tail;
          $values$$128 = append$$1(values, new List(matchValue$$26.fields[0], new List()));
          continue runner$$1;
        }
      }

      break;
    }
  };

  return runner$$1(decoders$$2, new List());
}
export function map(ctor, d1, path$$46, value$$81) {
  const matchValue$$27 = d1(path$$46, value$$81);

  if (matchValue$$27.tag === 1) {
    return new Result(1, "Error", matchValue$$27.fields[0]);
  } else {
    return new Result(0, "Ok", ctor(matchValue$$27.fields[0]));
  }
}
export function map2(ctor$$1, d1$$1, d2, path$$47, value$$82) {
  const matchValue$$28 = [d1$$1(path$$47, value$$82), d2(path$$47, value$$82)];

  if (matchValue$$28[0].tag === 1) {
    return new Result(1, "Error", matchValue$$28[0].fields[0]);
  } else if (matchValue$$28[1].tag === 1) {
    return new Result(1, "Error", matchValue$$28[1].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$1(matchValue$$28[0].fields[0], matchValue$$28[1].fields[0]));
  }
}
export function map3(ctor$$2, d1$$2, d2$$1, d3, path$$48, value$$83) {
  const matchValue$$29 = [d1$$2(path$$48, value$$83), d2$$1(path$$48, value$$83), d3(path$$48, value$$83)];

  if (matchValue$$29[0].tag === 1) {
    return new Result(1, "Error", matchValue$$29[0].fields[0]);
  } else if (matchValue$$29[1].tag === 1) {
    return new Result(1, "Error", matchValue$$29[1].fields[0]);
  } else if (matchValue$$29[2].tag === 1) {
    return new Result(1, "Error", matchValue$$29[2].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$2(matchValue$$29[0].fields[0], matchValue$$29[1].fields[0], matchValue$$29[2].fields[0]));
  }
}
export function map4(ctor$$3, d1$$3, d2$$2, d3$$1, d4, path$$49, value$$84) {
  const matchValue$$30 = [d1$$3(path$$49, value$$84), d2$$2(path$$49, value$$84), d3$$1(path$$49, value$$84), d4(path$$49, value$$84)];

  if (matchValue$$30[0].tag === 1) {
    return new Result(1, "Error", matchValue$$30[0].fields[0]);
  } else if (matchValue$$30[1].tag === 1) {
    return new Result(1, "Error", matchValue$$30[1].fields[0]);
  } else if (matchValue$$30[2].tag === 1) {
    return new Result(1, "Error", matchValue$$30[2].fields[0]);
  } else if (matchValue$$30[3].tag === 1) {
    return new Result(1, "Error", matchValue$$30[3].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$3(matchValue$$30[0].fields[0], matchValue$$30[1].fields[0], matchValue$$30[2].fields[0], matchValue$$30[3].fields[0]));
  }
}
export function map5(ctor$$4, d1$$4, d2$$3, d3$$2, d4$$1, d5, path$$50, value$$85) {
  const matchValue$$31 = [d1$$4(path$$50, value$$85), d2$$3(path$$50, value$$85), d3$$2(path$$50, value$$85), d4$$1(path$$50, value$$85), d5(path$$50, value$$85)];

  if (matchValue$$31[0].tag === 1) {
    return new Result(1, "Error", matchValue$$31[0].fields[0]);
  } else if (matchValue$$31[1].tag === 1) {
    return new Result(1, "Error", matchValue$$31[1].fields[0]);
  } else if (matchValue$$31[2].tag === 1) {
    return new Result(1, "Error", matchValue$$31[2].fields[0]);
  } else if (matchValue$$31[3].tag === 1) {
    return new Result(1, "Error", matchValue$$31[3].fields[0]);
  } else if (matchValue$$31[4].tag === 1) {
    return new Result(1, "Error", matchValue$$31[4].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$4(matchValue$$31[0].fields[0], matchValue$$31[1].fields[0], matchValue$$31[2].fields[0], matchValue$$31[3].fields[0], matchValue$$31[4].fields[0]));
  }
}
export function map6(ctor$$5, d1$$5, d2$$4, d3$$3, d4$$2, d5$$1, d6, path$$51, value$$86) {
  const matchValue$$32 = [d1$$5(path$$51, value$$86), d2$$4(path$$51, value$$86), d3$$3(path$$51, value$$86), d4$$2(path$$51, value$$86), d5$$1(path$$51, value$$86), d6(path$$51, value$$86)];

  if (matchValue$$32[0].tag === 1) {
    return new Result(1, "Error", matchValue$$32[0].fields[0]);
  } else if (matchValue$$32[1].tag === 1) {
    return new Result(1, "Error", matchValue$$32[1].fields[0]);
  } else if (matchValue$$32[2].tag === 1) {
    return new Result(1, "Error", matchValue$$32[2].fields[0]);
  } else if (matchValue$$32[3].tag === 1) {
    return new Result(1, "Error", matchValue$$32[3].fields[0]);
  } else if (matchValue$$32[4].tag === 1) {
    return new Result(1, "Error", matchValue$$32[4].fields[0]);
  } else if (matchValue$$32[5].tag === 1) {
    return new Result(1, "Error", matchValue$$32[5].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$5(matchValue$$32[0].fields[0], matchValue$$32[1].fields[0], matchValue$$32[2].fields[0], matchValue$$32[3].fields[0], matchValue$$32[4].fields[0], matchValue$$32[5].fields[0]));
  }
}
export function map7(ctor$$6, d1$$6, d2$$5, d3$$4, d4$$3, d5$$2, d6$$1, d7, path$$52, value$$87) {
  const matchValue$$33 = [d1$$6(path$$52, value$$87), d2$$5(path$$52, value$$87), d3$$4(path$$52, value$$87), d4$$3(path$$52, value$$87), d5$$2(path$$52, value$$87), d6$$1(path$$52, value$$87), d7(path$$52, value$$87)];

  if (matchValue$$33[0].tag === 1) {
    return new Result(1, "Error", matchValue$$33[0].fields[0]);
  } else if (matchValue$$33[1].tag === 1) {
    return new Result(1, "Error", matchValue$$33[1].fields[0]);
  } else if (matchValue$$33[2].tag === 1) {
    return new Result(1, "Error", matchValue$$33[2].fields[0]);
  } else if (matchValue$$33[3].tag === 1) {
    return new Result(1, "Error", matchValue$$33[3].fields[0]);
  } else if (matchValue$$33[4].tag === 1) {
    return new Result(1, "Error", matchValue$$33[4].fields[0]);
  } else if (matchValue$$33[5].tag === 1) {
    return new Result(1, "Error", matchValue$$33[5].fields[0]);
  } else if (matchValue$$33[6].tag === 1) {
    return new Result(1, "Error", matchValue$$33[6].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$6(matchValue$$33[0].fields[0], matchValue$$33[1].fields[0], matchValue$$33[2].fields[0], matchValue$$33[3].fields[0], matchValue$$33[4].fields[0], matchValue$$33[5].fields[0], matchValue$$33[6].fields[0]));
  }
}
export function map8(ctor$$7, d1$$7, d2$$6, d3$$5, d4$$4, d5$$3, d6$$2, d7$$1, d8, path$$53, value$$88) {
  const matchValue$$34 = [d1$$7(path$$53, value$$88), d2$$6(path$$53, value$$88), d3$$5(path$$53, value$$88), d4$$4(path$$53, value$$88), d5$$3(path$$53, value$$88), d6$$2(path$$53, value$$88), d7$$1(path$$53, value$$88), d8(path$$53, value$$88)];

  if (matchValue$$34[0].tag === 1) {
    return new Result(1, "Error", matchValue$$34[0].fields[0]);
  } else if (matchValue$$34[1].tag === 1) {
    return new Result(1, "Error", matchValue$$34[1].fields[0]);
  } else if (matchValue$$34[2].tag === 1) {
    return new Result(1, "Error", matchValue$$34[2].fields[0]);
  } else if (matchValue$$34[3].tag === 1) {
    return new Result(1, "Error", matchValue$$34[3].fields[0]);
  } else if (matchValue$$34[4].tag === 1) {
    return new Result(1, "Error", matchValue$$34[4].fields[0]);
  } else if (matchValue$$34[5].tag === 1) {
    return new Result(1, "Error", matchValue$$34[5].fields[0]);
  } else if (matchValue$$34[6].tag === 1) {
    return new Result(1, "Error", matchValue$$34[6].fields[0]);
  } else if (matchValue$$34[7].tag === 1) {
    return new Result(1, "Error", matchValue$$34[7].fields[0]);
  } else {
    return new Result(0, "Ok", ctor$$7(matchValue$$34[0].fields[0], matchValue$$34[1].fields[0], matchValue$$34[2].fields[0], matchValue$$34[3].fields[0], matchValue$$34[4].fields[0], matchValue$$34[5].fields[0], matchValue$$34[6].fields[0], matchValue$$34[7].fields[0]));
  }
}
export function dict(decoder$$20) {
  return function (path$$55) {
    return function (value$$90) {
      return map(function ctor$$8(elements) {
        return ofList(elements, {
          Compare: comparePrimitives
        });
      }, function d1$$8(path$$54, value$$89) {
        return keyValuePairs(decoder$$20, path$$54, value$$89);
      }, path$$55, value$$90);
    };
  };
}

function unwrapWith(errors$$1, path$$56, decoder$$22, value$$91) {
  let matchValue$$35;
  const clo1$$2 = partialApply(1, decoder$$22, [path$$56]);
  matchValue$$35 = clo1$$2(value$$91);

  if (matchValue$$35.tag === 1) {
    errors$$1.push(matchValue$$35.fields[0]);
    return null;
  } else {
    return matchValue$$35.fields[0];
  }
}

export const Getters$00601 = declare(function Thoth_Json_Decode_Getters(path$$57, v$$4) {
  const $this$$3 = this;
  $this$$3.errors = [];
  $this$$3.required = {
    Field(fieldName$$8, decoder$$23) {
      return unwrapWith($this$$3.errors, path$$57, function (path$$58, value$$92) {
        return field(fieldName$$8, decoder$$23, path$$58, value$$92);
      }, v$$4);
    },

    At(fieldNames$$3, decoder$$25) {
      return unwrapWith($this$$3.errors, path$$57, function (firstPath$$2, firstValue$$2) {
        return at(fieldNames$$3, decoder$$25, firstPath$$2, firstValue$$2);
      }, v$$4);
    },

    Raw(decoder$$27) {
      return unwrapWith($this$$3.errors, path$$57, decoder$$27, v$$4);
    }

  };
  $this$$3.optional = {
    Field(fieldName$$9, decoder$$28) {
      return unwrapWith($this$$3.errors, path$$57, function (path$$59, value$$93) {
        return optional(fieldName$$9, decoder$$28, path$$59, value$$93);
      }, v$$4);
    },

    At(fieldNames$$4, decoder$$30) {
      return unwrapWith($this$$3.errors, path$$57, function (firstPath$$3, firstValue$$3) {
        return optionalAt(fieldNames$$4, decoder$$30, firstPath$$3, firstValue$$3);
      }, v$$4);
    },

    Raw(decoder$$32) {
      let matchValue$$36;
      const clo1$$3 = partialApply(1, decoder$$32, [path$$57]);
      matchValue$$36 = clo1$$3(v$$4);

      if (matchValue$$36.tag === 1) {
        var $target$$197, v$$6;

        if (matchValue$$36.fields[0][1].tag === 1) {
          $target$$197 = 0;
          v$$6 = matchValue$$36.fields[0][1].fields[1];
        } else if (matchValue$$36.fields[0][1].tag === 2) {
          $target$$197 = 0;
          v$$6 = matchValue$$36.fields[0][1].fields[1];
        } else if (matchValue$$36.fields[0][1].tag === 3) {
          $target$$197 = 1;
        } else if (matchValue$$36.fields[0][1].tag === 4) {
          $target$$197 = 1;
        } else if (matchValue$$36.fields[0][1].tag === 5) {
          $target$$197 = 2;
        } else if (matchValue$$36.fields[0][1].tag === 6) {
          $target$$197 = 2;
        } else if (matchValue$$36.fields[0][1].tag === 7) {
          $target$$197 = 2;
        } else {
          $target$$197 = 0;
          v$$6 = matchValue$$36.fields[0][1].fields[1];
        }

        switch ($target$$197) {
          case 0:
            {
              if (v$$6 == null) {
                return null;
              } else {
                $this$$3.errors.push(matchValue$$36.fields[0]);
                return null;
              }
            }

          case 1:
            {
              return null;
            }

          case 2:
            {
              $this$$3.errors.push(matchValue$$36.fields[0]);
              return null;
            }
        }
      } else {
        return some(matchValue$$36.fields[0]);
      }
    }

  };
});
export function Getters$00601$reflection($gen$$198) {
  return type("Thoth.Json.Decode.Getters`1", [$gen$$198]);
}
export function Getters$00601$$$$002Ector$$4A51B60E(path$$57, v$$4) {
  return this instanceof Getters$00601 ? Getters$00601.call(this, path$$57, v$$4) : new Getters$00601(path$$57, v$$4);
}
export function Getters$00601$$get_Errors(__$$6) {
  return ofSeq(__$$6.errors);
}
Object.defineProperty(Getters$00601.prototype, "Required", {
  "get": function () {
    const __$$7 = this;
    return __$$7.required;
  }
});
Object.defineProperty(Getters$00601.prototype, "Optional", {
  "get": function () {
    const __$$8 = this;
    return __$$8.optional;
  }
});
export function object(builder, path$$60, v$$7) {
  const getters = Getters$00601$$$$002Ector$$4A51B60E(path$$60, v$$7);
  let result$$5;
  result$$5 = builder(getters);
  const matchValue$$37 = Getters$00601$$get_Errors(getters);

  if (matchValue$$37.tail != null) {
    if (length(matchValue$$37) > 1) {
      const errors$$3 = map$$1(function (tupledArg$$2) {
        return errorToString(tupledArg$$2[0], tupledArg$$2[1]);
      }, matchValue$$37);
      const arg0$$65 = [path$$60, new ErrorReason(7, "BadOneOf", errors$$3)];
      return new Result(1, "Error", arg0$$65);
    } else {
      return new Result(1, "Error", matchValue$$37.head);
    }
  } else {
    return new Result(0, "Ok", result$$5);
  }
}
export function tuple2(decoder1, decoder2) {
  return function (path$$65) {
    return function (value$$97) {
      return andThen(function cb$$2(v1$$8, path$$64, value$$96) {
        return andThen(function cb$$1(v2$$7, arg10$0040, arg20$0040) {
          return succeed([v1$$8, v2$$7], arg10$0040, arg20$0040);
        }, function (path$$63, value$$95) {
          return index(1, decoder2, path$$63, value$$95);
        }, path$$64, value$$96);
      }, function (path$$62, value$$94) {
        return index(0, decoder1, path$$62, value$$94);
      }, path$$65, value$$97);
    };
  };
}
export function tuple3(decoder1$$1, decoder2$$1, decoder3) {
  return function (path$$71) {
    return function (value$$103) {
      return andThen(function cb$$5(v1$$9, path$$70, value$$102) {
        return andThen(function cb$$4(v2$$8, path$$69, value$$101) {
          return andThen(function cb$$3(v3$$6, arg10$0040$$1, arg20$0040$$1) {
            return succeed([v1$$9, v2$$8, v3$$6], arg10$0040$$1, arg20$0040$$1);
          }, function (path$$68, value$$100) {
            return index(2, decoder3, path$$68, value$$100);
          }, path$$69, value$$101);
        }, function (path$$67, value$$99) {
          return index(1, decoder2$$1, path$$67, value$$99);
        }, path$$70, value$$102);
      }, function (path$$66, value$$98) {
        return index(0, decoder1$$1, path$$66, value$$98);
      }, path$$71, value$$103);
    };
  };
}
export function tuple4(decoder1$$2, decoder2$$2, decoder3$$1, decoder4) {
  return function (path$$79) {
    return function (value$$111) {
      return andThen(function cb$$9(v1$$10, path$$78, value$$110) {
        return andThen(function cb$$8(v2$$9, path$$77, value$$109) {
          return andThen(function cb$$7(v3$$7, path$$76, value$$108) {
            return andThen(function cb$$6(v4$$5, arg10$0040$$2, arg20$0040$$2) {
              return succeed([v1$$10, v2$$9, v3$$7, v4$$5], arg10$0040$$2, arg20$0040$$2);
            }, function (path$$75, value$$107) {
              return index(3, decoder4, path$$75, value$$107);
            }, path$$76, value$$108);
          }, function (path$$74, value$$106) {
            return index(2, decoder3$$1, path$$74, value$$106);
          }, path$$77, value$$109);
        }, function (path$$73, value$$105) {
          return index(1, decoder2$$2, path$$73, value$$105);
        }, path$$78, value$$110);
      }, function (path$$72, value$$104) {
        return index(0, decoder1$$2, path$$72, value$$104);
      }, path$$79, value$$111);
    };
  };
}
export function tuple5(decoder1$$3, decoder2$$3, decoder3$$2, decoder4$$1, decoder5) {
  return function (path$$89) {
    return function (value$$121) {
      return andThen(function cb$$14(v1$$11, path$$88, value$$120) {
        return andThen(function cb$$13(v2$$10, path$$87, value$$119) {
          return andThen(function cb$$12(v3$$8, path$$86, value$$118) {
            return andThen(function cb$$11(v4$$6, path$$85, value$$117) {
              return andThen(function cb$$10(v5$$4, arg10$0040$$3, arg20$0040$$3) {
                return succeed([v1$$11, v2$$10, v3$$8, v4$$6, v5$$4], arg10$0040$$3, arg20$0040$$3);
              }, function (path$$84, value$$116) {
                return index(4, decoder5, path$$84, value$$116);
              }, path$$85, value$$117);
            }, function (path$$83, value$$115) {
              return index(3, decoder4$$1, path$$83, value$$115);
            }, path$$86, value$$118);
          }, function (path$$82, value$$114) {
            return index(2, decoder3$$2, path$$82, value$$114);
          }, path$$87, value$$119);
        }, function (path$$81, value$$113) {
          return index(1, decoder2$$3, path$$81, value$$113);
        }, path$$88, value$$120);
      }, function (path$$80, value$$112) {
        return index(0, decoder1$$3, path$$80, value$$112);
      }, path$$89, value$$121);
    };
  };
}
export function tuple6(decoder1$$4, decoder2$$4, decoder3$$3, decoder4$$2, decoder5$$1, decoder6) {
  return function (path$$101) {
    return function (value$$133) {
      return andThen(function cb$$20(v1$$12, path$$100, value$$132) {
        return andThen(function cb$$19(v2$$11, path$$99, value$$131) {
          return andThen(function cb$$18(v3$$9, path$$98, value$$130) {
            return andThen(function cb$$17(v4$$7, path$$97, value$$129) {
              return andThen(function cb$$16(v5$$5, path$$96, value$$128) {
                return andThen(function cb$$15(v6$$3, arg10$0040$$4, arg20$0040$$4) {
                  return succeed([v1$$12, v2$$11, v3$$9, v4$$7, v5$$5, v6$$3], arg10$0040$$4, arg20$0040$$4);
                }, function (path$$95, value$$127) {
                  return index(5, decoder6, path$$95, value$$127);
                }, path$$96, value$$128);
              }, function (path$$94, value$$126) {
                return index(4, decoder5$$1, path$$94, value$$126);
              }, path$$97, value$$129);
            }, function (path$$93, value$$125) {
              return index(3, decoder4$$2, path$$93, value$$125);
            }, path$$98, value$$130);
          }, function (path$$92, value$$124) {
            return index(2, decoder3$$3, path$$92, value$$124);
          }, path$$99, value$$131);
        }, function (path$$91, value$$123) {
          return index(1, decoder2$$4, path$$91, value$$123);
        }, path$$100, value$$132);
      }, function (path$$90, value$$122) {
        return index(0, decoder1$$4, path$$90, value$$122);
      }, path$$101, value$$133);
    };
  };
}
export function tuple7(decoder1$$5, decoder2$$5, decoder3$$4, decoder4$$3, decoder5$$2, decoder6$$1, decoder7) {
  return function (path$$115) {
    return function (value$$147) {
      return andThen(function cb$$27(v1$$13, path$$114, value$$146) {
        return andThen(function cb$$26(v2$$12, path$$113, value$$145) {
          return andThen(function cb$$25(v3$$10, path$$112, value$$144) {
            return andThen(function cb$$24(v4$$8, path$$111, value$$143) {
              return andThen(function cb$$23(v5$$6, path$$110, value$$142) {
                return andThen(function cb$$22(v6$$4, path$$109, value$$141) {
                  return andThen(function cb$$21(v7$$2, arg10$0040$$5, arg20$0040$$5) {
                    return succeed([v1$$13, v2$$12, v3$$10, v4$$8, v5$$6, v6$$4, v7$$2], arg10$0040$$5, arg20$0040$$5);
                  }, function (path$$108, value$$140) {
                    return index(6, decoder7, path$$108, value$$140);
                  }, path$$109, value$$141);
                }, function (path$$107, value$$139) {
                  return index(5, decoder6$$1, path$$107, value$$139);
                }, path$$110, value$$142);
              }, function (path$$106, value$$138) {
                return index(4, decoder5$$2, path$$106, value$$138);
              }, path$$111, value$$143);
            }, function (path$$105, value$$137) {
              return index(3, decoder4$$3, path$$105, value$$137);
            }, path$$112, value$$144);
          }, function (path$$104, value$$136) {
            return index(2, decoder3$$4, path$$104, value$$136);
          }, path$$113, value$$145);
        }, function (path$$103, value$$135) {
          return index(1, decoder2$$5, path$$103, value$$135);
        }, path$$114, value$$146);
      }, function (path$$102, value$$134) {
        return index(0, decoder1$$5, path$$102, value$$134);
      }, path$$115, value$$147);
    };
  };
}
export function tuple8(decoder1$$6, decoder2$$6, decoder3$$5, decoder4$$4, decoder5$$3, decoder6$$2, decoder7$$1, decoder8) {
  return function (path$$131) {
    return function (value$$163) {
      return andThen(function cb$$35(v1$$14, path$$130, value$$162) {
        return andThen(function cb$$34(v2$$13, path$$129, value$$161) {
          return andThen(function cb$$33(v3$$11, path$$128, value$$160) {
            return andThen(function cb$$32(v4$$9, path$$127, value$$159) {
              return andThen(function cb$$31(v5$$7, path$$126, value$$158) {
                return andThen(function cb$$30(v6$$5, path$$125, value$$157) {
                  return andThen(function cb$$29(v7$$3, path$$124, value$$156) {
                    return andThen(function cb$$28(v8$$1, arg10$0040$$6, arg20$0040$$6) {
                      return succeed([v1$$14, v2$$13, v3$$11, v4$$9, v5$$7, v6$$5, v7$$3, v8$$1], arg10$0040$$6, arg20$0040$$6);
                    }, function (path$$123, value$$155) {
                      return index(7, decoder8, path$$123, value$$155);
                    }, path$$124, value$$156);
                  }, function (path$$122, value$$154) {
                    return index(6, decoder7$$1, path$$122, value$$154);
                  }, path$$125, value$$157);
                }, function (path$$121, value$$153) {
                  return index(5, decoder6$$2, path$$121, value$$153);
                }, path$$126, value$$158);
              }, function (path$$120, value$$152) {
                return index(4, decoder5$$3, path$$120, value$$152);
              }, path$$127, value$$159);
            }, function (path$$119, value$$151) {
              return index(3, decoder4$$4, path$$119, value$$151);
            }, path$$128, value$$160);
          }, function (path$$118, value$$150) {
            return index(2, decoder3$$5, path$$118, value$$150);
          }, path$$129, value$$161);
        }, function (path$$117, value$$149) {
          return index(1, decoder2$$6, path$$117, value$$149);
        }, path$$130, value$$162);
      }, function (path$$116, value$$148) {
        return index(0, decoder1$$6, path$$116, value$$148);
      }, path$$131, value$$163);
    };
  };
}

function toMap(xs) {
  return ofSeq$$1(xs, {
    Compare: compare
  });
}

function toSet(xs$$1) {
  return ofSeq$$2(xs$$1, {
    Compare: compare
  });
}

function autoObject(decoderInfos, path$$132, value$$164) {
  if (!(value$$164 === null ? false : Object.getPrototypeOf(value$$164 || false) === Object.prototype)) {
    const arg0$$66 = [path$$132, new ErrorReason(0, "BadPrimitive", "an object", value$$164)];
    return new Result(1, "Error", arg0$$66);
  } else {
    const state$$6 = new Result(0, "Ok", new List());
    return foldBack(function folder$$6(tupledArg$$3, acc$$8) {
      if (acc$$8.tag === 0) {
        const result$$7 = tupledArg$$3[1](path$$132 + "." + tupledArg$$3[0])(value$$164[tupledArg$$3[0]]);
        return mapOk(function mapping$$4(v$$8) {
          return new List(v$$8, acc$$8.fields[0]);
        }, result$$7);
      } else {
        return acc$$8;
      }
    }, decoderInfos, state$$6);
  }
}

function autoObject2(keyDecoder, valueDecoder, path$$133, value$$165) {
  if (!(value$$165 === null ? false : Object.getPrototypeOf(value$$165 || false) === Object.prototype)) {
    const arg0$$67 = [path$$133, new ErrorReason(0, "BadPrimitive", "an object", value$$165)];
    return new Result(1, "Error", arg0$$67);
  } else {
    const state$$7 = new Result(0, "Ok", new List());
    const source$$2 = Object.keys(value$$165);
    return fold$$2(function folder$$7(acc$$9, name$$17) {
      if (acc$$9.tag === 0) {
        let matchValue$$38;
        const clo1$$4 = partialApply(1, keyDecoder, [path$$133]);
        matchValue$$38 = clo1$$4(name$$17);

        if (matchValue$$38.tag === 0) {
          const _arg1$$5 = valueDecoder(path$$133 + "." + name$$17, value$$165[name$$17]);

          if (_arg1$$5.tag === 0) {
            const arg0$$68 = new List([matchValue$$38.fields[0], _arg1$$5.fields[0]], acc$$9.fields[0]);
            return new Result(0, "Ok", arg0$$68);
          } else {
            return new Result(1, "Error", _arg1$$5.fields[0]);
          }
        } else {
          return new Result(1, "Error", matchValue$$38.fields[0]);
        }
      } else {
        return acc$$9;
      }
    }, state$$7, source$$2);
  }
}

function mixedArray(msg$$12, decoders$$4, path$$134, values$$1) {
  var arg0$$69, arg10$$5, arg30, clo1$$5, clo2, clo3;

  if (decoders$$4.length !== values$$1.length) {
    const arg0$$70 = [path$$134, (arg0$$69 = (arg10$$5 = decoders$$4.length | 0, arg30 = values$$1.length | 0, (clo1$$5 = toText(printf("Expected %i %s but got %i")), clo2 = clo1$$5(arg10$$5), clo3 = clo2(msg$$12), clo3(arg30))), (new ErrorReason(6, "FailMessage", arg0$$69)))];
    return new Result(1, "Error", arg0$$70);
  } else {
    const state$$8 = new Result(0, "Ok", new List());
    return foldBack2(uncurry(3, mapCurriedArgs(function folder$$8(value$$166) {
      return function (decoder$$104) {
        return function (acc$$11) {
          if (acc$$11.tag === 0) {
            const result$$9 = decoder$$104(path$$134, value$$166);
            return mapOk(function mapping$$5(v$$10) {
              return new List(v$$10, acc$$11.fields[0]);
            }, result$$9);
          } else {
            return acc$$11;
          }
        };
      };
    }, [0, [0, 2], 0])), values$$1, decoders$$4, state$$8);
  }
}

function makeUnion(extra, caseStrategy, t, name$$18, path$$135, values$$2) {
  let uci;
  const array$$5 = getUnionCases(t, true);
  uci = tryFind(function predicate(x$$14) {
    return name$$22(x$$14) === name$$18;
  }, array$$5);

  if (uci != null) {
    const uci$$1 = uci;

    if (values$$2.length === 0) {
      const arg0$$72 = makeUnion$$1(uci$$1, [], true);
      return new Result(0, "Ok", arg0$$72);
    } else {
      let decoders$$5;
      const array$$6 = getUnionCaseFields(uci$$1);
      decoders$$5 = map$$2(function mapping$$6(fi) {
        return autoDecoder(extra, caseStrategy, false, fi[1]);
      }, array$$6, Array);
      const result$$10 = mixedArray("union fields", decoders$$5, path$$135, values$$2);
      return mapOk(function mapping$$7(values$$3) {
        return makeUnion$$1(uci$$1, ofList$$1(values$$3, Array), true);
      }, result$$10);
    }
  } else {
    const arg0$$71 = [path$$135, new ErrorReason(6, "FailMessage", "Cannot find case " + name$$18 + " in " + fullName(t))];
    return new Result(1, "Error", arg0$$71);
  }
}

function autoDecodeRecordsAndUnions(extra$$1, caseStrategy$$1, isOptional, t$$1) {
  const decoderRef = new FSharpRef(null);
  let extra$$2;
  const key = fullName(t$$1);
  extra$$2 = add(key, decoderRef, extra$$1);
  let decoder$$105;

  if (isRecord(t$$1, true)) {
    let decoders$$6;
    const array$$7 = getRecordElements(t$$1, true);
    decoders$$6 = map$$2(function mapping$$8(fi$$1) {
      const name$$19 = Util$0024002ECasing$0024$0024$0024convert(caseStrategy$$1, name$$22(fi$$1));
      return [name$$19, autoDecoder(extra$$2, caseStrategy$$1, false, fi$$1[1])];
    }, array$$7, Array);

    decoder$$105 = function (path$$136) {
      return function (value$$167) {
        const result$$11 = autoObject(decoders$$6, path$$136, value$$167);
        return mapOk(function mapping$$9(xs$$2) {
          return makeRecord(t$$1, ofList$$1(xs$$2, Array), true);
        }, result$$11);
      };
    };
  } else if (isUnion(t$$1, true)) {
    decoder$$105 = function (path$$137) {
      return function (value$$168) {
        if (typeof value$$168 === "string") {
          const name$$20 = value$$168;
          return makeUnion(extra$$2, caseStrategy$$1, t$$1, name$$20, path$$137, []);
        } else if (Array.isArray(value$$168)) {
          const values$$4 = value$$168;
          let name$$21;
          const o$$77 = values$$4[0];
          name$$21 = o$$77;
          return makeUnion(extra$$2, caseStrategy$$1, t$$1, name$$21, path$$137, values$$4.slice(1, values$$4.length));
        } else {
          const arg0$$73 = [path$$137, new ErrorReason(0, "BadPrimitive", "a string or array", value$$168)];
          return new Result(1, "Error", arg0$$73);
        }
      };
    };
  } else if (isOptional) {
    decoder$$105 = function d(path$$138) {
      return function (value$$169) {
        return new Result(1, "Error", [path$$138, new ErrorReason(2, "BadType", "an extra coder for " + fullName(t$$1), value$$169)]);
      };
    };
  } else {
    let message;
    const arg10$$6 = fullName(t$$1);
    const clo1$$6 = toText(printf("Cannot generate auto decoder for %s. Please pass an extra decoder."));
    message = clo1$$6(arg10$$6);
    throw new Error(message);
  }

  decoderRef.contents = decoder$$105;
  return decoder$$105;
}

function autoDecoder(extra$$3, caseStrategy$$2, isOptional$$1, t$$2) {
  var clo1$$7, decoder$$121;
  const fullname = fullName(t$$2);
  const matchValue$$39 = tryFind$$1(fullname, extra$$3);

  if (matchValue$$39 == null) {
    if (isArray(t$$2)) {
      let decoder$$106;
      const t$$3 = getElementType(t$$2);
      decoder$$106 = autoDecoder(extra$$3, caseStrategy$$2, false, t$$3);
      return function (path$$140) {
        return function (value$$171) {
          return array(uncurry(2, decoder$$106), path$$140, value$$171);
        };
      };
    } else if (isEnum(t$$2)) {
      const enumType = fullName(getEnumUnderlyingType(t$$2));

      if (enumType === "System.SByte") {
        return function (path$$141) {
          return function (value$$173) {
            const matchValue$$40 = sbyte(path$$141)(value$$173);

            if (matchValue$$40.tag === 1) {
              return new Result(1, "Error", matchValue$$40.fields[0]);
            } else {
              let _arg1$$6;

              let source$$4;
              const source$$3 = getEnumValues(t$$2);
              source$$4 = source$$3;
              _arg1$$6 = contains(matchValue$$40.fields[0], source$$4);

              if (_arg1$$6) {
                const arg0$$74 = parseEnum(t$$2, (matchValue$$40.fields[0].toString()));
                return new Result(0, "Ok", arg0$$74);
              } else {
                const arg0$$75 = [path$$141, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$173, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$75);
              }
            }
          };
        };
      } else if (enumType === "System.Byte") {
        return function (path$$143) {
          return function (value$$176) {
            const matchValue$$41 = byte$(path$$143)(value$$176);

            if (matchValue$$41.tag === 1) {
              return new Result(1, "Error", matchValue$$41.fields[0]);
            } else {
              let _arg1$$7;

              let source$$6;
              const source$$5 = getEnumValues(t$$2);
              source$$6 = source$$5;
              _arg1$$7 = contains(matchValue$$41.fields[0], source$$6);

              if (_arg1$$7) {
                const arg0$$76 = parseEnum(t$$2, (matchValue$$41.fields[0].toString()));
                return new Result(0, "Ok", arg0$$76);
              } else {
                const arg0$$77 = [path$$143, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$176, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$77);
              }
            }
          };
        };
      } else if (enumType === "System.Int16") {
        return function (path$$145) {
          return function (value$$179) {
            const matchValue$$42 = int16(path$$145)(value$$179);

            if (matchValue$$42.tag === 1) {
              return new Result(1, "Error", matchValue$$42.fields[0]);
            } else {
              let _arg1$$8;

              let source$$8;
              const source$$7 = getEnumValues(t$$2);
              source$$8 = source$$7;
              _arg1$$8 = contains(matchValue$$42.fields[0], source$$8);

              if (_arg1$$8) {
                const arg0$$78 = parseEnum(t$$2, (int16ToString(matchValue$$42.fields[0])));
                return new Result(0, "Ok", arg0$$78);
              } else {
                const arg0$$79 = [path$$145, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$179, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$79);
              }
            }
          };
        };
      } else if (enumType === "System.UInt16") {
        return function (path$$147) {
          return function (value$$182) {
            const matchValue$$43 = uint16(path$$147)(value$$182);

            if (matchValue$$43.tag === 1) {
              return new Result(1, "Error", matchValue$$43.fields[0]);
            } else {
              let _arg1$$9;

              let source$$10;
              const source$$9 = getEnumValues(t$$2);
              source$$10 = source$$9;
              _arg1$$9 = contains(matchValue$$43.fields[0], source$$10);

              if (_arg1$$9) {
                const arg0$$80 = parseEnum(t$$2, (matchValue$$43.fields[0].toString()));
                return new Result(0, "Ok", arg0$$80);
              } else {
                const arg0$$81 = [path$$147, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$182, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$81);
              }
            }
          };
        };
      } else if (enumType === "System.Int32") {
        return function (path$$149) {
          return function (value$$185) {
            const matchValue$$44 = int$(path$$149)(value$$185);

            if (matchValue$$44.tag === 1) {
              return new Result(1, "Error", matchValue$$44.fields[0]);
            } else {
              let _arg1$$10;

              let source$$12;
              const source$$11 = getEnumValues(t$$2);
              source$$12 = source$$11;
              _arg1$$10 = contains(matchValue$$44.fields[0], source$$12);

              if (_arg1$$10) {
                const arg0$$82 = parseEnum(t$$2, (int32ToString(matchValue$$44.fields[0])));
                return new Result(0, "Ok", arg0$$82);
              } else {
                const arg0$$83 = [path$$149, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$185, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$83);
              }
            }
          };
        };
      } else if (enumType === "System.UInt32") {
        return function (path$$151) {
          return function (value$$188) {
            const matchValue$$45 = uint32(path$$151)(value$$188);

            if (matchValue$$45.tag === 1) {
              return new Result(1, "Error", matchValue$$45.fields[0]);
            } else {
              let _arg1$$11;

              let source$$14;
              const source$$13 = getEnumValues(t$$2);
              source$$14 = source$$13;
              _arg1$$11 = contains(matchValue$$45.fields[0], source$$14);

              if (_arg1$$11) {
                const arg0$$84 = parseEnum(t$$2, (matchValue$$45.fields[0].toString()));
                return new Result(0, "Ok", arg0$$84);
              } else {
                const arg0$$85 = [path$$151, new ErrorReason(1, "BadPrimitiveExtra", fullName(t$$2), value$$188, "Unkown value provided for the enum")];
                return new Result(1, "Error", arg0$$85);
              }
            }
          };
        };
      } else {
        return (clo1$$7 = toFail(printf("Cannot generate auto decoder for %s.\nThoth.Json.Net only support the folluwing enum types:\n- sbyte\n- byte\n- int16\n- uint16\n- int\n- uint32\nIf you can't use one of these types, please pass an extra decoder.\n                    ")), function (arg10$$7) {
          const clo2$$1 = clo1$$7(arg10$$7);
          return function (arg20$$1) {
            const clo3$$1 = clo2$$1(arg20$$1);
            return function (arg30$$1) {
              return clo3$$1(arg30$$1);
            };
          };
        })(fullName(t$$2));
      }
    } else if (isGenericType(t$$2)) {
      if (isTuple(t$$2)) {
        let decoders$$7;
        const array$$8 = getTupleElements(t$$2);
        decoders$$7 = map$$2(function mapping$$10(t$$10) {
          return autoDecoder(extra$$3, caseStrategy$$2, false, t$$10);
        }, array$$8, Array);
        return function (path$$153) {
          return function (value$$190) {
            if (Array.isArray(value$$190)) {
              const result$$12 = mixedArray("tuple elements", decoders$$7, path$$153, value$$190);
              return mapOk(function mapping$$11(xs$$3) {
                return makeTuple(ofList$$1(xs$$3, Array), t$$2);
              }, result$$12);
            } else {
              const arg0$$86 = [path$$153, new ErrorReason(0, "BadPrimitive", "an array", value$$190)];
              return new Result(1, "Error", arg0$$86);
            }
          };
        };
      } else {
        const fullname$$1 = fullName(getGenericTypeDefinition(t$$2));

        if (fullname$$1 === "Microsoft.FSharp.Core.FSharpOption`1[System.Object]") {
          let d$$15;
          let decoder$$119;
          const t$$11 = getGenerics(t$$2)[0];
          decoder$$119 = autoDecoder(extra$$3, caseStrategy$$2, true, t$$11);

          d$$15 = function (path$$154) {
            return function (value$$191) {
              return option(uncurry(2, decoder$$119), path$$154, value$$191);
            };
          };

          return d$$15;
        } else if (fullname$$1 === "Microsoft.FSharp.Collections.FSharpList`1[System.Object]") {
          let d$$17;
          let decoder$$120;
          const t$$12 = getGenerics(t$$2)[0];
          decoder$$120 = autoDecoder(extra$$3, caseStrategy$$2, false, t$$12);

          d$$17 = function (path$$155) {
            return function (value$$192) {
              return list(uncurry(2, decoder$$120), path$$155, value$$192);
            };
          };

          return d$$17;
        } else if (fullname$$1 === "Microsoft.FSharp.Collections.FSharpMap`2[System.Object,System.Object]") {
          let keyDecoder$$1;
          const t$$13 = getGenerics(t$$2)[0];
          keyDecoder$$1 = autoDecoder(extra$$3, caseStrategy$$2, false, t$$13);
          let valueDecoder$$1;
          const t$$14 = getGenerics(t$$2)[1];
          valueDecoder$$1 = autoDecoder(extra$$3, caseStrategy$$2, false, t$$14);
          let d1$$9;
          const decoders$$8 = ofArray([function (path$$156) {
            return function (value$$193) {
              return autoObject2(uncurry(2, keyDecoder$$1), uncurry(2, valueDecoder$$1), path$$156, value$$193);
            };
          }, (decoder$$121 = tuple2(uncurry(2, keyDecoder$$1), uncurry(2, valueDecoder$$1)), function (path$$157) {
            return function (value$$194) {
              return list(uncurry(2, decoder$$121), path$$157, value$$194);
            };
          })]);

          d1$$9 = function (path$$158) {
            return function (value$$195) {
              return oneOf(decoders$$8, path$$158, value$$195);
            };
          };

          return function (path$$159) {
            return function (value$$197) {
              return map(function ctor$$9(ar) {
                const value$$196 = toMap(ar);
                return value$$196;
              }, uncurry(2, d1$$9), path$$159, value$$197);
            };
          };
        } else if (fullname$$1 === "Microsoft.FSharp.Collections.FSharpSet`1[System.Object]") {
          let decoder$$122;
          const t$$15 = getGenerics(t$$2)[0];
          decoder$$122 = autoDecoder(extra$$3, caseStrategy$$2, false, t$$15);
          return function (path$$160) {
            return function (value$$198) {
              const matchValue$$46 = array(uncurry(2, decoder$$122), path$$160, value$$198);

              if (matchValue$$46.tag === 0) {
                let arg0$$87;
                const value$$199 = toSet(matchValue$$46.fields[0]);
                arg0$$87 = value$$199;
                return new Result(0, "Ok", arg0$$87);
              } else {
                return new Result(1, "Error", matchValue$$46.fields[0]);
              }
            };
          };
        } else {
          return autoDecodeRecordsAndUnions(extra$$3, caseStrategy$$2, isOptional$$1, t$$2);
        }
      }
    } else if (fullname === "System.Boolean") {
      return function d$$19(path$$161) {
        return function (value$$200) {
          return bool(path$$161, value$$200);
        };
      };
    } else if (fullname === "Microsoft.FSharp.Core.Unit") {
      return function d$$20(path$$162) {
        return function (value$$201) {
          return unit(path$$162, value$$201);
        };
      };
    } else if (fullname === "System.String") {
      return function d$$21(path$$163) {
        return function (value$$202) {
          return string(path$$163, value$$202);
        };
      };
    } else if (fullname === "System.SByte") {
      return sbyte;
    } else if (fullname === "System.Byte") {
      return byte$;
    } else if (fullname === "System.Int16") {
      return int16;
    } else if (fullname === "System.UInt16") {
      return uint16;
    } else if (fullname === "System.Int32") {
      return int$;
    } else if (fullname === "System.UInt32") {
      return uint32;
    } else if (fullname === "System.Double") {
      return function d$$28(path$$164) {
        return function (value$$203) {
          return float$(path$$164, value$$203);
        };
      };
    } else if (fullname === "System.Single") {
      return function d$$29(path$$165) {
        return function (value$$204) {
          return float32(path$$165, value$$204);
        };
      };
    } else if (fullname === "System.DateTime") {
      return function d$$30(path$$166) {
        return function (value$$205) {
          return datetime(path$$166, value$$205);
        };
      };
    } else if (fullname === "System.DateTimeOffset") {
      return function d$$31(path$$167) {
        return function (value$$206) {
          return datetimeOffset(path$$167, value$$206);
        };
      };
    } else if (fullname === "System.TimeSpan") {
      return function d$$32(path$$168) {
        return function (value$$207) {
          return timespan(path$$168, value$$207);
        };
      };
    } else if (fullname === "System.Guid") {
      return function d$$33(path$$169) {
        return function (value$$208) {
          return guid(path$$169, value$$208);
        };
      };
    } else if (fullname === "System.Object") {
      return function (_arg1$$12) {
        return function (v$$11) {
          return new Result(0, "Ok", v$$11);
        };
      };
    } else {
      return autoDecodeRecordsAndUnions(extra$$3, caseStrategy$$2, isOptional$$1, t$$2);
    }
  } else {
    const decoderRef$$1 = matchValue$$39;
    return function (path$$139) {
      return function (value$$170) {
        return decoderRef$$1.contents(path$$139)(value$$170);
      };
    };
  }
}

function makeExtra(extra$$4) {
  if (extra$$4 != null) {
    const e$$1 = extra$$4;
    return map$$3(function (_arg2$$1, tupledArg$$4) {
      return new FSharpRef(tupledArg$$4[1]);
    }, e$$1.Coders);
  } else {
    return empty({
      Compare: comparePrimitives
    });
  }
}

export const Auto = declare(function Thoth_Json_Decode_Auto() {});
export function Auto$reflection() {
  return type("Thoth.Json.Decode.Auto");
}
export function Auto$$$generateDecoderCached$$7848D058(caseStrategy$$3, extra$$5, resolver) {
  const t$$16 = resolver.ResolveType();
  const caseStrategy$$4 = defaultArg(caseStrategy$$3, new CaseStrategy(0, "PascalCase"));
  let key$$1;
  let y$$1;
  const y = fullName(t$$16);
  const x$$15 = String(caseStrategy$$4);
  y$$1 = x$$15 + y;
  let x$$16;
  let option$$3;
  option$$3 = map$$4(function mapping$$12(e$$2) {
    return e$$2.Hash;
  }, extra$$5);
  x$$16 = defaultArg(option$$3, "");
  key$$1 = x$$16 + y$$1;
  const d$$34 = Util$0024002ECache$002400601$0024$0024GetOrAdd$0024$002443981464(Util$0024$0024$0024CachedDecoders, key$$1, function () {
    return autoDecoder(makeExtra(extra$$5), caseStrategy$$4, false, t$$16);
  });
  return d$$34;
}
export function Auto$$$generateDecoder$$7848D058(caseStrategy$$5, extra$$6, resolver$$2) {
  const caseStrategy$$6 = defaultArg(caseStrategy$$5, new CaseStrategy(0, "PascalCase"));
  let d$$36;
  const t$$17 = resolver$$2.ResolveType();
  const extra$$7 = makeExtra(extra$$6);
  d$$36 = autoDecoder(extra$$7, caseStrategy$$6, false, t$$17);
  return d$$36;
}
export function Auto$$$fromString$$Z5CB6BD(json$$1, caseStrategy$$7, extra$$8, resolver$$4) {
  const decoder$$123 = Auto$$$generateDecoder$$7848D058(caseStrategy$$7, extra$$8, resolver$$4);
  return fromString(uncurry(2, decoder$$123), json$$1);
}
export function Auto$$$unsafeFromString$$Z5CB6BD(json$$2, caseStrategy$$8, extra$$9, resolver$$5) {
  const decoder$$124 = Auto$$$generateDecoder$$7848D058(caseStrategy$$8, extra$$9, resolver$$5);
  const matchValue$$47 = fromString(uncurry(2, decoder$$124), json$$2);

  if (matchValue$$47.tag === 1) {
    throw new Error(matchValue$$47.fields[0]);
  } else {
    return matchValue$$47.fields[0];
  }
}