import { Record, declare, Union } from "../fable-library.2.4.11/Types";
import { record, type, tuple, lambda, union, list, obj, string } from "../fable-library.2.4.11/Reflection";
import { Result } from "../fable-library.2.4.11/Option";
import { addToDict, tryGetValue } from "../fable-library.2.4.11/Util";
import { replace } from "../fable-library.2.4.11/RegExp";
export const ErrorReason = declare(function Thoth_Json_ErrorReason(tag, name, ...fields) {
  Union.call(this, tag, name, ...fields);
}, Union);
export function ErrorReason$reflection() {
  return union("Thoth.Json.ErrorReason", [], ErrorReason, () => [["BadPrimitive", [string, obj]], ["BadPrimitiveExtra", [string, obj, string]], ["BadType", [string, obj]], ["BadField", [string, obj]], ["BadPath", [string, obj, string]], ["TooSmallArray", [string, obj]], ["FailMessage", [string]], ["BadOneOf", [list(string)]]]);
}
export const CaseStrategy = declare(function Thoth_Json_CaseStrategy(tag, name, ...fields) {
  Union.call(this, tag, name, ...fields);
}, Union);
export function CaseStrategy$reflection() {
  return union("Thoth.Json.CaseStrategy", [], CaseStrategy, () => ["PascalCase", "CamelCase", "SnakeCase"]);
}
export const ExtraCoders = declare(function Thoth_Json_ExtraCoders(arg1, arg2) {
  this.Hash = arg1;
  this.Coders = arg2;
}, Record);
export function ExtraCoders$reflection() {
  return record("Thoth.Json.ExtraCoders", [], ExtraCoders, () => [["Hash", string], ["Coders", type("Microsoft.FSharp.Collections.FSharpMap`2", [string, tuple(lambda(obj, obj), lambda(string, lambda(obj, union("Microsoft.FSharp.Core.FSharpResult`2", [obj, tuple(string, ErrorReason$reflection())], Result, () => [["Ok", [obj]], ["Error", [tuple(string, ErrorReason$reflection())]]]))))])]]);
}
export const Util$002ECache$00601 = declare(function Thoth_Json_Util_Cache() {
  const $this$$1 = this;
  $this$$1.cache = new Map([]);
});
export function Util$002ECache$00601$reflection($gen$$2) {
  return type("Thoth.Json.Util.Cache`1", [$gen$$2]);
}
export function Util$002ECache$00601$$$$002Ector() {
  return this instanceof Util$002ECache$00601 ? Util$002ECache$00601.call(this) : new Util$002ECache$00601();
}
export function Util$002ECache$00601$$GetOrAdd$$43981464(__, key, factory) {
  const matchValue = tryGetValue(__.cache, key, null);

  if (matchValue[0]) {
    return matchValue[1];
  } else {
    const x$$1 = factory();
    addToDict(__.cache, key, x$$1);
    return x$$1;
  }
}
export const Util$$$CachedEncoders = Util$002ECache$00601$$$$002Ector();
export const Util$$$CachedDecoders = Util$002ECache$00601$$$$002Ector();
export function Util$002ECasing$$$lowerFirst(str) {
  return str.slice(null, 0 + 1).toLowerCase() + str.slice(1, str.length);
}
export function Util$002ECasing$$$convert(caseStrategy, fieldName) {
  switch (caseStrategy.tag) {
    case 2:
      {
        return replace(Util$002ECasing$$$lowerFirst(fieldName), "[A-Z]", "_$0").toLowerCase();
      }

    case 0:
      {
        return fieldName;
      }

    default:
      {
        return Util$002ECasing$$$lowerFirst(fieldName);
      }
  }
}